'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var StyledHeader = function StyledHeader(component) {
  return (0, _styledComponents2.default)(component).withConfig({
    displayName: '_Header'
  })(['text-align:left;cursor:', ';user-select:none;width:', ';&:hover{color:', ';}'], function (props) {
    return props.sortable ? 'pointer' : 'inherit';
  }, function (props) {
    return props.width;
  }, function (props) {
    return props.sortable ? props.theme.colors.blue700 : 'inherit';
  });
};

var Header = function (_React$Component) {
  _inherits(Header, _React$Component);

  function Header() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Header);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Header.__proto__ || Object.getPrototypeOf(Header)).call.apply(_ref, [this].concat(args))), _this), _this.handleClick = function (ev) {
      var _this$props = _this.props,
          onClick = _this$props.onClick,
          value = _this$props.value,
          sortable = _this$props.sortable;


      if (onClick && sortable) {
        onClick(ev, value);
      }
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Header, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          className = _props.className,
          children = _props.children,
          order = _props.order,
          sortable = _props.sortable,
          title = _props.title;


      return _react2.default.createElement(
        'td',
        { onClick: this.handleClick, className: className, title: title },
        children,
        ' ',
        order && sortable && _react2.default.createElement('i', {
          className: order === 'asc' ? 'fa fa-caret-up' : 'fa fa-caret-down'
        })
      );
    }
  }]);

  return Header;
}(_react2.default.Component);

// Only way to declare default props :(


var Styled = StyledHeader(Header);

Styled.propTypes = {
  /**
   * Whether or not the column will be sortable
   */
  sortable: _propTypes2.default.bool,
  /**
   * The width that will be applied to the column
   */
  width: _propTypes2.default.string,
  /**
   * Sort order. Should be either `asc` or `desc`
   */
  order: _propTypes2.default.oneOf(['asc', 'desc'])
};

Styled.defaultProps = {
  sortable: true
};

exports.default = Styled;