'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.shapes = undefined;

var _isEmpty2 = require('lodash/isEmpty');

var _isEmpty3 = _interopRequireDefault(_isEmpty2);

var _keys2 = require('lodash/keys');

var _keys3 = _interopRequireDefault(_keys2);

var _noop2 = require('lodash/noop');

var _noop3 = _interopRequireDefault(_noop2);

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _templateObject = _taggedTemplateLiteral(['\n  color: ', ';\n  font-size: ', ';\n  margin-top: 4px;\n'], ['\n  color: ', ';\n  font-size: ', ';\n  margin-top: 4px;\n']),
    _templateObject2 = _taggedTemplateLiteral(['\n  color: ', ';\n  font-size: ', ';\n  margin-top: -7px;\n'], ['\n  color: ', ';\n  font-size: ', ';\n  margin-top: -7px;\n']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _polished = require('polished');

var _theme = require('../../theme');

var _theme2 = _interopRequireDefault(_theme);

var _MatchedText = require('../MatchedText');

var _MatchedText2 = _interopRequireDefault(_MatchedText);

var _ShapeCircle = require('./shapes/_ShapeCircle');

var _ShapeCircle2 = _interopRequireDefault(_ShapeCircle);

var _ShapeTriangle = require('./shapes/_ShapeTriangle');

var _ShapeTriangle2 = _interopRequireDefault(_ShapeTriangle);

var _ShapeSquare = require('./shapes/_ShapeSquare');

var _ShapeSquare2 = _interopRequireDefault(_ShapeSquare);

var _ShapePentagon = require('./shapes/_ShapePentagon');

var _ShapePentagon2 = _interopRequireDefault(_ShapePentagon);

var _ShapeHexagon = require('./shapes/_ShapeHexagon');

var _ShapeHexagon2 = _interopRequireDefault(_ShapeHexagon);

var _ShapeHeptagon = require('./shapes/_ShapeHeptagon');

var _ShapeHeptagon2 = _interopRequireDefault(_ShapeHeptagon);

var _ShapeOctagon = require('./shapes/_ShapeOctagon');

var _ShapeOctagon2 = _interopRequireDefault(_ShapeOctagon);

var _ShapeCloud = require('./shapes/_ShapeCloud');

var _ShapeCloud2 = _interopRequireDefault(_ShapeCloud);

var _ShapeSheet = require('./shapes/_ShapeSheet');

var _ShapeSheet2 = _interopRequireDefault(_ShapeSheet);

var _ShapeCylinder = require('./shapes/_ShapeCylinder');

var _ShapeCylinder2 = _interopRequireDefault(_ShapeCylinder);

var _ShapeDottedCylinder = require('./shapes/_ShapeDottedCylinder');

var _ShapeDottedCylinder2 = _interopRequireDefault(_ShapeDottedCylinder);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var shapes = exports.shapes = {
  circle: _ShapeCircle2.default,
  triangle: _ShapeTriangle2.default,
  square: _ShapeSquare2.default,
  pentagon: _ShapePentagon2.default,
  hexagon: _ShapeHexagon2.default,
  heptagon: _ShapeHeptagon2.default,
  octagon: _ShapeOctagon2.default,
  cloud: _ShapeCloud2.default,
  sheet: _ShapeSheet2.default,
  cylinder: _ShapeCylinder2.default,
  dottedcylinder: _ShapeDottedCylinder2.default
};

var nodeBaseSize = 100;
var labelWidth = nodeBaseSize * 1.4;

var GraphNodeWrapper = _styledComponents2.default.g.attrs({
  transform: function transform(props) {
    return 'scale(' + props.size / nodeBaseSize + ')';
  }
}).withConfig({
  displayName: 'GraphNode__GraphNodeWrapper'
})(['cursor:pointer;']);

var SvgTextContainer = _styledComponents2.default.g.attrs({
  transform: function transform(props) {
    return 'translate(0, ' + (props.y + 85) + ')';
  }
}).withConfig({
  displayName: 'GraphNode__SvgTextContainer'
})(['pointer-events:all;']);

var LabelSvg = _styledComponents2.default.text.attrs({
  fill: function fill(props) {
    return props.contrastMode ? props.theme.colors.black : props.theme.colors.purple800;
  },
  transform: 'scale(1.7)',
  textAnchor: 'middle'
}).withConfig({
  displayName: 'GraphNode__LabelSvg'
})(['font-size:', ';'], function (props) {
  return props.theme.fontSizes.normal;
});

var LabelMinorSvg = _styledComponents2.default.text.attrs({
  fill: function fill(props) {
    return props.contrastMode ? props.theme.colors.black : props.theme.colors.purple600;
  },
  transform: 'scale(1.7)',
  textAnchor: 'middle',
  y: 20
}).withConfig({
  displayName: 'GraphNode__LabelMinorSvg'
})(['font-size:', ';'], function (props) {
  return props.theme.fontSizes.small;
});

var LabelsStandardContainer = _styledComponents2.default.div.withConfig({
  displayName: 'GraphNode__LabelsStandardContainer'
})(['transform-origin:top;transform:scale(1.7);']);

var LabelTemplate = _styledComponents2.default.div.withConfig({
  displayName: 'GraphNode__LabelTemplate'
})(['background-color:', ';border-radius:', ';overflow:hidden;text-overflow:ellipsis;display:inline-block;text-align:center;padding:2px 10px;max-width:100%;', ';'], function (props) {
  return (0, _polished.transparentize)(0.2, props.contrastMode ? props.theme.colors.white : props.theme.colors.purple25);
}, function (props) {
  return props.theme.borderRadius.soft;
}, function (props) {
  return !props.highlighted && '\n      white-space: nowrap;\n    ';
});

var LabelStandard = LabelTemplate.extend(_templateObject, function (props) {
  return props.contrastMode ? props.theme.colors.black : props.theme.colors.purple800;
}, function (props) {
  return props.theme.fontSizes.normal;
});

var LabelMinorStandard = LabelTemplate.extend(_templateObject2, function (props) {
  return props.contrastMode ? props.theme.colors.black : props.theme.colors.purple600;
}, function (props) {
  return props.theme.fontSizes.small;
});

/**
 * A component for rendering labeled graph nodes.
 */

var GraphNode = function (_React$Component) {
  _inherits(GraphNode, _React$Component);

  function GraphNode() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, GraphNode);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = GraphNode.__proto__ || Object.getPrototypeOf(GraphNode)).call.apply(_ref, [this].concat(args))), _this), _this.findFirstSearchMatch = function (text) {
      var match = {};
      _this.props.searchTerms.forEach(function (term) {
        var start = text.search(term);
        if ((0, _isEmpty3.default)(match) && start !== -1) {
          match = { start: start, length: term.length };
        }
      });
      return match;
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(GraphNode, [{
    key: 'renderSvgLabels',
    value: function renderSvgLabels() {
      return _react2.default.createElement(
        SvgTextContainer,
        { y: this.props.labelOffset },
        _react2.default.createElement(
          LabelSvg,
          { contrastMode: this.props.contrastMode },
          this.props.label
        ),
        _react2.default.createElement(
          LabelMinorSvg,
          { contrastMode: this.props.contrastMode },
          this.props.labelMinor
        )
      );
    }
  }, {
    key: 'renderStandardLabels',
    value: function renderStandardLabels() {
      var _props = this.props,
          label = _props.label,
          labelMinor = _props.labelMinor,
          highlighted = _props.highlighted,
          contrastMode = _props.contrastMode,
          labelOffset = _props.labelOffset;


      return _react2.default.createElement(
        'foreignObject',
        {
          y: nodeBaseSize / 2 + labelOffset,
          x: -0.5 * labelWidth,
          width: labelWidth,
          height: '100px',
          style: {
            textAlign: 'center',
            pointerEvents: 'all'
          }
        },
        _react2.default.createElement(
          LabelsStandardContainer,
          null,
          _react2.default.createElement(
            LabelStandard,
            { highlighted: highlighted, contrastMode: contrastMode },
            _react2.default.createElement(_MatchedText2.default, {
              noBorder: true,
              text: label,
              match: this.findFirstSearchMatch(label)
            })
          ),
          !(0, _isEmpty3.default)(labelMinor) && _react2.default.createElement(
            LabelMinorStandard,
            {
              highlighted: highlighted,
              contrastMode: contrastMode
            },
            _react2.default.createElement(_MatchedText2.default, {
              noBorder: true,
              text: labelMinor,
              match: this.findFirstSearchMatch(labelMinor)
            })
          ),
          this.props.renderAppendedInfo()
        )
      );
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var Shape = shapes[this.props.shape];

      return _react2.default.createElement(
        GraphNodeWrapper,
        {
          onMouseEnter: function onMouseEnter(ev) {
            return _this2.props.onMouseEnter(_this2.props.id, ev);
          },
          onMouseLeave: function onMouseLeave(ev) {
            return _this2.props.onMouseLeave(_this2.props.id, ev);
          },
          onClick: function onClick(ev) {
            return _this2.props.onClick(_this2.props.id, ev);
          },
          size: this.props.size
        },
        this.props.renderPrependedInfo(),
        this.props.forceSvg ? this.renderSvgLabels() : this.renderStandardLabels(),
        _react2.default.createElement(Shape, {
          id: this.props.id,
          size: nodeBaseSize,
          stacked: this.props.stacked,
          color: this.props.color,
          metricColor: this.props.metricColor,
          metricFormattedValue: this.props.metricFormattedValue,
          metricNumericValue: this.props.metricNumericValue,
          highlighted: this.props.highlighted,
          contrastMode: this.props.contrastMode
        })
      );
    }
  }]);

  return GraphNode;
}(_react2.default.Component);

GraphNode.propTypes = {
  /**
   * A unique node ID
   */
  id: _propTypes2.default.string.isRequired,
  /**
   * Shape of the rendered node (e.g. 'hexagon')
   */
  shape: _propTypes2.default.oneOf((0, _keys3.default)(shapes)).isRequired,
  /**
   * The node main label displayed right under the node shape
   */
  label: _propTypes2.default.string.isRequired,
  /**
   * Secondary label displayed below the main label in a smaller font
   */
  labelMinor: _propTypes2.default.string,
  /**
   * Vertical offset (in pixels) of the labels
   */
  labelOffset: _propTypes2.default.number,
  /**
   * Shows a stack of nodes instead of a singular node if true
   */
  stacked: _propTypes2.default.bool,
  /**
   * If true, shows the glow around the node as well as its metric data
   */
  highlighted: _propTypes2.default.bool,
  /**
   * The color of the node in any of the standard formats
   */
  color: _propTypes2.default.string,
  /**
   * The radius of the shape in pixels
   */
  size: _propTypes2.default.number,
  /**
   * Renders the node in a high contrast mode
   */
  contrastMode: _propTypes2.default.bool,
  /**
   * Displays all the node labels as SVG elements
   */
  forceSvg: _propTypes2.default.bool,
  /**
   * The background color of the node metric fill
   */
  metricColor: _propTypes2.default.string,
  /**
   * The formatted metric value to be displayed inside the node when highlighted
   */
  metricFormattedValue: _propTypes2.default.string,
  /**
   * The numeric value in the interval [0, 1] representing the amount of metric fill
   */
  metricNumericValue: _propTypes2.default.number,
  /**
   * Search terms to be applied on the node
   */
  searchTerms: _propTypes2.default.arrayOf(_propTypes2.default.string),
  /**
   * Render function for the info to be displayed before node labels (not working in full SVG mode)
   */
  renderPrependedInfo: _propTypes2.default.func,
  /**
   * Render function for the info to be displayed after node labels (not working in full SVG mode)
   */
  renderAppendedInfo: _propTypes2.default.func,
  /**
   * Callback for mouse pointer entering the node
   */
  onMouseEnter: _propTypes2.default.func,
  /**
   * Callback for mouse pointer leaving the node
   */
  onMouseLeave: _propTypes2.default.func,
  /**
   * Callback for mouse click on the node
   */
  onClick: _propTypes2.default.func
};

GraphNode.defaultProps = {
  labelMinor: '',
  labelOffset: 0,
  stacked: false,
  highlighted: false,
  color: _theme2.default.colors.purple400,
  size: nodeBaseSize,
  contrastMode: false,
  forceSvg: false,
  metricColor: _theme2.default.colors.status.warning,
  metricFormattedValue: '',
  metricNumericValue: null,
  searchTerms: [],
  renderPrependedInfo: _noop3.default,
  renderAppendedInfo: _noop3.default,
  onMouseEnter: _noop3.default,
  onMouseLeave: _noop3.default,
  onClick: _noop3.default
};

exports.default = GraphNode;