'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _DeploymentAnnotation = require('../_DeploymentAnnotation');

var _DeploymentAnnotation2 = _interopRequireDefault(_DeploymentAnnotation);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _toArray(arr) { return Array.isArray(arr) ? arr : Array.from(arr); }

var DeploymentAnnotationsWrapper = _styledComponents2.default.div.withConfig({
  displayName: '_DeploymentAnnotations__DeploymentAnnotationsWrapper'
})(['pointer-events:none;position:absolute;width:100%;height:100%;']);

var formattedDeployments = function formattedDeployments(_ref) {
  var deployments = _ref.deployments,
      timeScale = _ref.timeScale,
      chartWidth = _ref.chartWidth;
  return deployments.map(function (_ref2) {
    var Data = _ref2.Data,
        Stamp = _ref2.Stamp;

    var _Data$split = Data.split(', '),
        _Data$split2 = _toArray(_Data$split),
        action = _Data$split2[0],
        serviceIDs = _Data$split2.slice(1);

    return {
      key: Data + ' --- ' + Stamp,
      position: timeScale((0, _moment2.default)(Stamp).unix()),
      timestamp: (0, _moment2.default)(Stamp).format(),
      serviceIDs: serviceIDs,
      action: action
    };
  }).filter(function (_ref3) {
    var position = _ref3.position;
    return (
      // Filter out all the deployments that fall out of the chart.
      chartWidth >= position && position >= 0
    );
  });
};

var DeploymentAnnotations = function (_React$PureComponent) {
  _inherits(DeploymentAnnotations, _React$PureComponent);

  function DeploymentAnnotations(props) {
    _classCallCheck(this, DeploymentAnnotations);

    var _this = _possibleConstructorReturn(this, (DeploymentAnnotations.__proto__ || Object.getPrototypeOf(DeploymentAnnotations)).call(this, props));

    _this.state = {
      deployments: formattedDeployments(props)
    };
    return _this;
  }

  _createClass(DeploymentAnnotations, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      this.setState({ deployments: formattedDeployments(nextProps) });
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props$timeScale$doma = this.props.timeScale.domain(),
          _props$timeScale$doma2 = _slicedToArray(_props$timeScale$doma, 2),
          startTimeSec = _props$timeScale$doma2[0],
          endTimeSec = _props$timeScale$doma2[1];

      if (!startTimeSec || !endTimeSec) return null;

      return _react2.default.createElement(
        DeploymentAnnotationsWrapper,
        null,
        this.state.deployments.map(function (deployment) {
          return _react2.default.createElement(_DeploymentAnnotation2.default, {
            key: deployment.key,
            x: deployment.position,
            action: deployment.action,
            serviceIDs: deployment.serviceIDs,
            timestamp: deployment.timestamp,
            containerWidth: _this2.props.chartWidth,
            containerHeight: _this2.props.chartHeight,
            onAxis: true
          });
        })
      );
    }
  }]);

  return DeploymentAnnotations;
}(_react2.default.PureComponent);

DeploymentAnnotations.propTypes = {
  chartWidth: _propTypes2.default.number.isRequired,
  chartHeight: _propTypes2.default.number.isRequired,
  timeScale: _propTypes2.default.func.isRequired,
  deployments: _propTypes2.default.array.isRequired
};

exports.default = DeploymentAnnotations;