'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _get2 = require('lodash/get');

var _get3 = _interopRequireDefault(_get2);

var _find2 = require('lodash/find');

var _find3 = _interopRequireDefault(_find2);

var _map2 = require('lodash/map');

var _map3 = _interopRequireDefault(_map2);

var _pick2 = require('lodash/pick');

var _pick3 = _interopRequireDefault(_pick2);

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Tab = require('./Tab');

var _Tab2 = _interopRequireDefault(_Tab);

var _TabButton = require('./_TabButton');

var _TabButton2 = _interopRequireDefault(_TabButton);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TabButtons = _styledComponents2.default.div.withConfig({
  displayName: 'TabSelect__TabButtons'
})(['']);

var borders = function borders(props) {
  return '\n    border-top-right-radius: ' + props.theme.borderRadius.soft + ';\n    border-bottom-right-radius: ' + props.theme.borderRadius.soft + ';\n    border-bottom-left-radius: ' + props.theme.borderRadius.soft + ';\n    border: 1px solid ' + props.theme.colors.purple100 + ';\n';
};

var bordersOnlyTop = function bordersOnlyTop(props) {
  return '\n  border-top: 1px solid ' + props.theme.colors.purple100 + '\n';
};

var TabContent = _styledComponents2.default.div.withConfig({
  displayName: 'TabSelect__TabContent'
})(['padding:', ';background-color:', ';', ';'], function (props) {
  return props.small ? '10px' : '20px';
}, function (props) {
  return props.secondary ? 'transparent' : props.theme.colors.white;
}, function (props) {
  return props.secondary ? bordersOnlyTop(props) : borders(props);
});

var Styled = function Styled(component) {
  return (0, _styledComponents2.default)(component).withConfig({
    displayName: 'TabSelect'
  })(['']);
};

var TabSelect = function (_React$PureComponent) {
  _inherits(TabSelect, _React$PureComponent);

  function TabSelect() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, TabSelect);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = TabSelect.__proto__ || Object.getPrototypeOf(TabSelect)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      selectedTab:
      // Use the first tab as the default if no selectedTab prop is specified.
      _this.props.selectedTab || (0, _get3.default)(_this.props.children, '[0].props.name')
    }, _this.isSelectedTab = function (_ref2) {
      var name = _ref2.name;
      return name === _this.state.selectedTab;
    }, _this.handleTabClick = function (ev, tabName) {
      _this.setState({ selectedTab: tabName });

      if (_this.props.onChange) {
        _this.props.onChange(ev, tabName);
      }
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(TabSelect, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      // Always override user-selected tab with the default one from
      // the prop input (so that URL param can take precedence).
      if (nextProps.selectedTab !== this.props.selectedTab) {
        this.setState({ selectedTab: nextProps.selectedTab });
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          className = _props.className,
          children = _props.children,
          secondary = _props.secondary,
          small = _props.small;

      var tabs = _react2.default.Children.map(children, function (child) {
        return (0, _pick3.default)(child.props, ['label', 'name']);
      });

      var selected = (0, _find3.default)(children, function (c) {
        return _this2.isSelectedTab(c.props);
      });

      return _react2.default.createElement(
        'div',
        { className: className },
        _react2.default.createElement(
          TabButtons,
          null,
          (0, _map3.default)(tabs, function (tab) {
            return _react2.default.createElement(
              _TabButton2.default,
              {
                key: tab.name,
                name: tab.name,
                selected: _this2.isSelectedTab(tab),
                secondary: secondary,
                small: small,
                onClick: _this2.handleTabClick
              },
              tab.label
            );
          })
        ),
        _react2.default.createElement(
          TabContent,
          { small: small, secondary: secondary },
          selected
        )
      );
    }
  }]);

  return TabSelect;
}(_react2.default.PureComponent);

TabSelect.propTypes = {
  /**
   * Secondary styling for TabSelect without border around content and
   * transparent background
   */
  secondary: _propTypes2.default.bool,
  /**
   * Small styling for TabSelect
   */
  small: _propTypes2.default.bool,
  /**
   * The tab to show on first render.
   * Supplying a new value to this prop will override the currently selected item
   */
  selectedTab: _propTypes2.default.string,
  /**
   * Children of `TabSelect` must be a `Tab` component
   */
  children: function children(props, propName) {
    var error = null;
    _react2.default.Children.forEach(props[propName], function (child) {
      if (child.type !== _Tab2.default) {
        error = new Error('Wrong component supplied to TabSelect. Expected a <Tab />, got a ' + child.type);
      }
    });
    return error;
  }
};

TabSelect.defaultProps = {
  secondary: false,
  small: false
};

exports.default = Styled(TabSelect);