'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _TimestampTag = require('../TimestampTag');

var _TimestampTag2 = _interopRequireDefault(_TimestampTag);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TooltipContainer = _styledComponents2.default.div.attrs({
  // Using attrs prevents extensive styled components
  // generation every time the tooltip is repositioned.
  style: function style(_ref) {
    var offsetX = _ref.offsetX,
        offsetY = _ref.offsetY;
    return { left: offsetX, top: offsetY };
  }
}).withConfig({
  displayName: 'TimestampTooltip__TooltipContainer'
})(['color:', ';background-color:', ';border:1px solid ', ';border-radius:', ';z-index:', ';padding:10px 15px;position:absolute;margin-top:20px;margin-left:10px;pointer-events:none;min-width:250px;max-width:500px;opacity:0.95;', ';'], function (props) {
  return props.theme.colors.purple900;
}, function (props) {
  return props.theme.colors.gray50;
}, function (props) {
  return props.theme.colors.gray200;
}, function (props) {
  return props.theme.borderRadius.soft;
}, function (props) {
  return props.theme.layers.tooltip;
}, function (props) {
  return !props.visible && 'opacity: 0;';
});

var TimestampWrapper = _styledComponents2.default.div.withConfig({
  displayName: 'TimestampTooltip__TimestampWrapper'
})(['margin-bottom:8px;']);

var TimestampTooltip = function (_React$PureComponent) {
  _inherits(TimestampTooltip, _React$PureComponent);

  function TimestampTooltip(props) {
    _classCallCheck(this, TimestampTooltip);

    var _this = _possibleConstructorReturn(this, (TimestampTooltip.__proto__ || Object.getPrototypeOf(TimestampTooltip)).call(this, props));

    _this.saveTooltipRef = function (ref) {
      _this.tooltipRef = ref;
    };

    _this.state = {
      prerendered: false
    };
    return _this;
  }

  _createClass(TimestampTooltip, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      // HACK: We wait for the first render to finish to get the accurate width
      // of the tooltip for calculating its position, keeping the tooltip invisible
      // through the first render cycle. After the first render has finished,
      // we set a 'prerender' flag to true force second render which actually
      // displays the tooltip. This is to prevent tooltip flickering before
      // we get its proper size.
      setTimeout(function () {
        _this2.setState({ prerendered: true });
      }, 0);
    }
  }, {
    key: 'getTooltipBoundingRect',
    value: function getTooltipBoundingRect() {
      return this.tooltipRef ? this.tooltipRef.getBoundingClientRect() : { width: 0, height: 0, top: 0, left: 0 };
    }
  }, {
    key: 'render',
    value: function render() {
      var _getTooltipBoundingRe = this.getTooltipBoundingRect(),
          width = _getTooltipBoundingRe.width;

      var _props = this.props,
          offsetX = _props.offsetX,
          offsetY = _props.offsetY,
          timestamp = _props.timestamp,
          containerWidth = _props.containerWidth;

      var clampedX = Math.min(offsetX, containerWidth - width - 10);

      return _react2.default.createElement(
        TooltipContainer,
        {
          offsetX: clampedX,
          offsetY: offsetY,
          visible: this.state.prerendered,
          innerRef: this.saveTooltipRef
        },
        _react2.default.createElement(
          TimestampWrapper,
          null,
          _react2.default.createElement(_TimestampTag2.default, { timestamp: timestamp })
        ),
        this.props.children
      );
    }
  }]);

  return TimestampTooltip;
}(_react2.default.PureComponent);

TimestampTooltip.propTypes = {
  containerWidth: _propTypes2.default.number.isRequired,
  timestamp: _propTypes2.default.string.isRequired,
  offsetX: _propTypes2.default.number,
  offsetY: _propTypes2.default.number
};

TimestampTooltip.defaultProps = {
  offsetX: 0,
  offsetY: 0
};

exports.default = TimestampTooltip;