'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.borderRadius = undefined;

var _forEach2 = require('lodash/forEach');

var _forEach3 = _interopRequireDefault(_forEach2);

var _kebabCase2 = require('lodash/kebabCase');

var _kebabCase3 = _interopRequireDefault(_kebabCase2);

exports.themeBorderRadiiAsScss = themeBorderRadiiAsScss;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var borderRadius = exports.borderRadius = {
  none: '0',
  soft: '4px',
  circle: '50%'
};

// Collects all theme border radii as SCSS vars.
function themeBorderRadiiAsScss() {
  var themeBorderRadii = [];

  (0, _forEach3.default)(borderRadius, function (value, name) {
    themeBorderRadii.push('$border-radius-' + (0, _kebabCase3.default)(name) + ': ' + value);
  });

  return themeBorderRadii;
}