"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.fontSizes = exports.fontFamilies = undefined;

var _forEach2 = require("lodash/forEach");

var _forEach3 = _interopRequireDefault(_forEach2);

var _kebabCase2 = require("lodash/kebabCase");

var _kebabCase3 = _interopRequireDefault(_kebabCase2);

exports.themeFontsAsScss = themeFontsAsScss;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var fontFamilies = exports.fontFamilies = {
  regular: "'proxima-nova', Helvetica, Arial, sans-serif",
  monospace: "'Roboto Mono', monospace"
};

var fontSizes = exports.fontSizes = {
  huge: '48px',
  extraLarge: '32px',
  large: '22px',
  normal: '16px',
  small: '14px',
  tiny: '12px'
};

// Collects all theme font vars as SCSS vars.
function themeFontsAsScss() {
  var themeFonts = [];

  (0, _forEach3.default)(fontFamilies, function (value, name) {
    themeFonts.push("$font-family-" + (0, _kebabCase3.default)(name) + ": " + value);
  });

  (0, _forEach3.default)(fontSizes, function (value, name) {
    themeFonts.push("$font-size-" + (0, _kebabCase3.default)(name) + ": " + value);
  });

  return themeFonts;
}